# Vo všetkých sadách platí $3\leq n\leq 100\,000$, $1\leq k\leq 1\,000\,000$, $k\leq {n\choose 3}$ a $1\leq a_1 < a_2 < \cdots < a_n\leq 10^{12}$.
# 
# V prvých troch sadách platí $n\leq 500$. V ďalších troch sadách platí $n\leq 7000$. 

import sys, re

data = sys.stdin.readlines()
assert len(data) == 2

assert re.match(r'^[1-9]\d* [1-9]\d*\n$', data[0])
N, K = [ int(x) for x in data[0].split() ]

assert 1 <= N <= 10**5
assert 1 <= K <= 10**6
assert K <= ( N*(N-1)*(N-2)//6 )

assert re.match(r'^[1-9]\d*( [1-9]\d*)*\n$', data[1])
A = [ int(x) for x in data[1].split() ]

assert len(A) == N
assert 1 <= A[0]
assert A[-1] <= 10**12
assert A == sorted(A)
assert len(set(A)) == N

print('OK',N)

